package com.fjhx.victoriatourist.entity.jd.bo;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;

@Getter
@Setter
@Data
@ColumnWidth(25)
@HeadRowHeight(20)
@ContentRowHeight(18)
public class JdBackQualityWaitExcelBo implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 京东待质检id
     */
    @ColumnWidth(15)
    @ExcelProperty("京东待质检id")
    private Long id;

    /**
     * 产品id
     */
    @ExcelProperty("产品id")
    private Long productId;

    /**
     * 待质检数量
     */
    @ExcelProperty("待质检数量")
    private BigDecimal quantity;

    /**
     * 产品编号
     */
    @ExcelProperty("产品编号")
    private String productCode;

    /**
     * 产品类型
     */
    @ExcelProperty("产品类型")
    private String productType;

    /**
     * 产品名称
     */
    @ExcelProperty("产品名称")
    private String productName;

    /**
     * 产品规格
     */
    @ExcelProperty("产品规格")
    private String productSpec;

    /**
     * 产品单位
     */
    @ExcelProperty("产品单位")
    private String productUnit;

    @ExcelProperty("质检合格数量")
    private BigDecimal qualifiedQuantity;

    @ExcelProperty("质检不合格数量")
    private BigDecimal disqualificationQuantity;

}
